unit ShellViewFormUnit;

interface


uses
  Windows, Messages, SysUtils,
  Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, SxShellViewForm, SxProvider, ImgList, ComCtrls, ExtCtrls,
  StdCtrls;

type
  TExampleShellViewForm = class(TSxShellViewForm)
    ListView: TListView;
    ImageList1: TImageList;
    Panel: TPanel;
    Button1: TButton;
    procedure SxShellViewFormProcessItems(Sender: TSxShellViewForm;
      CurrentProvider: TSxCustomProvider; DataGrains: TSxDataGrainList);
    procedure ListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListViewDeletion(Sender: TObject; Item: TListItem);
    procedure SxShellViewFormClearItems(Sender: TObject);
    procedure ListViewDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TExampleShellViewForm.SxShellViewFormProcessItems(
  Sender: TSxShellViewForm; CurrentProvider: TSxCustomProvider;
  DataGrains: TSxDataGrainList);
var
  i:Integer;
  ListItem:TListItem;
  currentRootGrain:TSxCustomDataGrain;
begin
  currentRootGrain:=ShellFolder.GetFolderGrain;
  try
    Panel.Caption:='Current folder is: '+currentRootGrain.Name;
  finally
    ShellFolder.ReleaseDataGrain(currentRootGrain);
  end;
  for i:=0 to DataGrains.Count-1 do
  begin
    ListItem:=ListView.Items.Add;
    ListItem.Caption:=DataGrains[i].Name;
    ListItem.Data:=DataGrains[i].Clone;
    if DataGrains[i].GrainType=gtFolder then
       ListItem.ImageIndex:=0
    else
       ListItem.ImageIndex:=1;
  end;
end;

procedure TExampleShellViewForm.ListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Selected then
     SelectedDataGrain:=TSxCustomDataGrain(Item.Data)
  else
     SelectedDataGrain:=nil;
end;

procedure TExampleShellViewForm.ListViewDeletion(Sender: TObject;
  Item: TListItem);
begin
  if Item.Data<>nil then
  begin
    TSxCustomDataGrain(Item.Data).Free;
    Item.Data:=nil;
  end;
end;

procedure TExampleShellViewForm.SxShellViewFormClearItems(Sender: TObject);
begin
  ListView.Items.Clear;
end;

procedure TExampleShellViewForm.ListViewDblClick(Sender: TObject);
begin
  if ListView.Selected<>nil then
     ExploreDataGrain(ListView.Selected.Data)
end;

procedure TExampleShellViewForm.Button1Click(Sender: TObject);
var
  tempGrains:TSxDataGrainList;
  tempGrain:TSxCustomDataGrain;
begin
  tempGrains:=TSxDataGrainList.Create(True);
  try
    tempGrain:=ShellFolder.GetFolderGrain;
    try
      ExploreDataGrain(tempGrain);
    finally
      FreeAndNil(tempGrain);
    end;
  finally
    FreeAndNil(tempGrains);
  end;
end;

initialization
  RegisterShellViewFormClass(TExampleShellViewForm);

end.
